/*!
  @file
  @author Shin'ichiro Nakaoka
*/

#ifndef CNOID_BODY_COLDET_LINK_PAIR_H_INCLUDED
#define CNOID_BODY_COLDET_LINK_PAIR_H_INCLUDED

#include <cnoid/ColdetModelPair>
#include <boost/weak_ptr.hpp>
#include "exportdecl.h"

namespace cnoid {
    
    class Link;
    class Body;
    typedef boost::shared_ptr<Body> BodyPtr;
    
    class CNOID_EXPORT ColdetLinkPair : public ColdetModelPair
    {
      public:
        ColdetLinkPair(const BodyPtr& body1, Link* link1, const BodyPtr& body2, Link* link2);
        
        ColdetLinkPair(const ColdetLinkPair& org);
        
        virtual ~ColdetLinkPair();
        
        void updatePositions();

        const BodyPtr& body(int index) const { return bodies[index]; }
        Link* link(int index) const { return links[index]; }
        
      protected:
        BodyPtr bodies[2];
        Link* links[2];
    };
    
    typedef boost::shared_ptr<ColdetLinkPair> ColdetLinkPairPtr;
}

#endif
