/**
   \file
   \author Shin'ichiro Nakaoka
*/

#include "Device.h"
#include "Link.h"

using namespace cnoid;


DeviceState::~DeviceState()
{

}


Device::Device()
{
    ns = new NonState;
    setId(-1);
    setLink(0);
    //T().setIdentity();
    T_local().setIdentity();
    setCycle(20.0);
    setStateSize(0);
}


Device::Device(const Device& org, bool stateOnly)
{
    if(stateOnly){
        ns = 0;
    } else {
        ns = new NonState;
        setName(org.name());
        setId(org.id());
        setLink(0);
        //T() = org.T();
        T_local() = org.T_local();
        setCycle(org.cycle());
        setStateSize(org.stateSize());
    }
}


Device::~Device()
{
    if(ns){
        delete ns;
    }
}


/*
void Device::updatePosition()
{
    setRotation(link()->attitude() * localRotation());
    setTranslation(link()->attitude() * localTranslation() + link()->p);
}
*/


void Device::forEachActualType(boost::function<bool(const std::type_info& type)> func)
{
    func(typeid(Device));
}


void Device::initializeState()
{

}


void Device::readState(const double* in_buf)
{

}


void Device::writeState(double* out_buf) const
{

}

